Create a custom event type
Registers a custom event type custom.<name> for a realm, so notification rules can be set for it before the first event arrives.
Requires a realm operator (or higher) with the rules.manage.realm permission on the realm given by realm_id.
POST
/
v1
/
events
/
custom
/
create
Create a custom event type
curl --request POST \
--url https://{host}/v1/events/custom/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"event_type": "custom.security_finding",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"label": "Security finding"
}
'import requests
url = "https://{host}/v1/events/custom/create"
payload = {
"event_type": "custom.security_finding",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"label": "Security finding"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
event_type: 'custom.security_finding',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
label: 'Security finding'
})
};
fetch('https://{host}/v1/events/custom/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/events/custom/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'event_type' => 'custom.security_finding',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'label' => 'Security finding'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/events/custom/create"
payload := strings.NewReader("{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/events/custom/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/events/custom/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"event": {
"id": "3e4f5a6b-7c8d-4e9f-8a0b-1c2d3e4f5a6b",
"event_type": "custom.security_finding",
"source": "manual",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"team_slug": null,
"label": "Security finding",
"created_at": 1759000000000
}
}{
"ok": false,
"error": {
"code": "unauthorized",
"message": "Authentication required"
}
}{
"ok": false,
"error": {
"code": "forbidden",
"message": "You do not have access to do this"
}
}{
"ok": false,
"error": {
"code": "not_found",
"message": "Not found"
}
}{
"ok": false,
"error": "Event 'custom.security_finding' already exists in this realm.",
"code": "conflict"
}{
"ok": false,
"error": "Required",
"code": "invalid_params",
"details": {
"issues": [
{
"field": "event_type",
"message": "Required"
}
]
}
}{
"ok": false,
"error": "Internal server error",
"code": "internal_error"
}Authorizations
User PAT (cliq_tok_…, including session-scoped) or realm token (cliq_dt_…).
Body
application/json
⌘I
Create a custom event type
curl --request POST \
--url https://{host}/v1/events/custom/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"event_type": "custom.security_finding",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"label": "Security finding"
}
'import requests
url = "https://{host}/v1/events/custom/create"
payload = {
"event_type": "custom.security_finding",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"label": "Security finding"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
event_type: 'custom.security_finding',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
label: 'Security finding'
})
};
fetch('https://{host}/v1/events/custom/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/events/custom/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'event_type' => 'custom.security_finding',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'label' => 'Security finding'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/events/custom/create"
payload := strings.NewReader("{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/events/custom/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/events/custom/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"event_type\": \"custom.security_finding\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"label\": \"Security finding\"\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"event": {
"id": "3e4f5a6b-7c8d-4e9f-8a0b-1c2d3e4f5a6b",
"event_type": "custom.security_finding",
"source": "manual",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"team_slug": null,
"label": "Security finding",
"created_at": 1759000000000
}
}{
"ok": false,
"error": {
"code": "unauthorized",
"message": "Authentication required"
}
}{
"ok": false,
"error": {
"code": "forbidden",
"message": "You do not have access to do this"
}
}{
"ok": false,
"error": {
"code": "not_found",
"message": "Not found"
}
}{
"ok": false,
"error": "Event 'custom.security_finding' already exists in this realm.",
"code": "conflict"
}{
"ok": false,
"error": "Required",
"code": "invalid_params",
"details": {
"issues": [
{
"field": "event_type",
"message": "Required"
}
]
}
}{
"ok": false,
"error": "Internal server error",
"code": "internal_error"
}